#include "component_physics.h"

/* Sets physics component info. */
void
component_physics_init
(
	ComponentPhysics* self, 
	vec3 position, 
	f32 velocityMax, 
	f32 friction
)
{
	glm_vec3_copy(position, self->position);
	glm_vec3_zero(self->velocity);
	self->friction = friction;
	self->velocityMax = velocityMax;
}

/* Ticks physics component. */
void
component_physics_tick(ComponentPhysics* self, ECS* ecs)
{
	self->velocity[0] = CLAMP(self->velocity[0], -self->velocityMax, self->velocityMax);
	self->velocity[1] = CLAMP(self->velocity[1], -self->velocityMax, self->velocityMax);
	self->velocity[2] = CLAMP(self->velocity[2], -self->velocityMax, self->velocityMax);
	
	glm_vec3_add(self->velocity, self->position, self->position);

	glm_vec3_scale(self->velocity, self->friction, self->velocity);
}
