#include "component_shoot.h"

/* DEPENDENCIES: Physics */

/* Sets shoot component info. */
void
component_shoot_init
(
	ComponentShoot* self, 
	EntityGameObjectInit projectileInit, 
	f32 speed, 
	f32 offset
)
{
	self->projectileInit = projectileInit;
	self->speed = speed;
	self->offset = offset;
}

/* Ticks shoot component. */
void
component_shoot_tick(ComponentShoot* self, ECS* ecs)
{
	if (self->isFire)
	{
		//ComponentGameObject* gameObject;
		ComponentPhysics* physics;
		u32 projectile;
		vec3 position;
		//vec3 velocity;

		//gameObject = ecs_component_get(ecs, ECS_COMPONENT_GAME_OBJECT, self->id);
		physics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->id);

		glm_vec3_copy(physics->position, position);

		projectile = ecs_entity_add(ecs);

		self->projectileInit(ecs, projectile, position);

		self->isFire = false;
	}
}
