#pragma once

#include "component/component_ammo.h"
#include "component/component_shoot.h"
#include "component/component_control_shoot.h"
#include "component/component_control_move.h"
#include "component/component_game_object.h"
#include "component/component_health.h"
#include "component/component_lifetime.h"
#include "component/component_physics.h"
#include "component/component_sprite.h"

#include "ecs_component.h"

static const ECSComponentInfo ECS_COMPONENT_INFO[ECS_COMPONENT_COUNT] = 
{
	COMPONENT_PHYSICS_INFO,
	COMPONENT_SHOOT_INFO,
	COMPONENT_CONTROL_MOVE_INFO,
	COMPONENT_CONTROL_SHOOT_INFO,
	COMPONENT_HEALTH_INFO,
	COMPONENT_AMMO_INFO,
	COMPONENT_SPRITE_INFO,
	COMPONENT_GAME_OBJECT_INFO,
	COMPONENT_LIFETIME_INFO
};

void ecs_tick(ECS* self);
void ecs_draw(ECS* self);
void ecs_init(ECS* self, Game* game);
void ecs_clear(ECS* self);
void ecs_free(ECS* self);
