#include "entity_player.h"

/* Initializes a player entity. */
void
entity_player_init(ECS* ecs, u32 id, vec3 position)
{
	ComponentGameObject* gameObject;
	ComponentControlMove* controlMove;
	ComponentShoot* shoot;

	gameObject = ecs_component_add(ecs, ECS_COMPONENT_GAME_OBJECT, id);
	controlMove = ecs_component_add(ecs, ECS_COMPONENT_CONTROL_MOVE, id);
	shoot = ecs_component_add(ecs, ECS_COMPONENT_SHOOT, id);
	
	ecs_component_add(ecs, ECS_COMPONENT_CONTROL_SHOOT, id);

	component_game_object_init
	(
		gameObject,
		ecs,
		ecs->game->resources.textures[TEXTURE_PLAYER],
		SHADER_TEXTURE_QUAD,
		ORIGIN_CENTER,
		(f32*)PLAYER_SIZE,
		position,
		(f32*)COLOR_OPAQUE,
		PLAYER_FRICTION,
		PLAYER_VELOCITY_MAX
	);

	component_control_move_init(controlMove, PLAYER_SPEED);

	component_shoot_init
	(
		shoot,
		(EntityGameObjectInit)entity_snake_init,
		PLAYER_SHOOT_SPEED,
		PLAYER_SHOOT_OFFSET
	);
}
